//
//  ViewController.m
//  PaymentControlDemo
//
//  Created by qcao on 15/10/20.
//  Copyright © 2015年 China Unionpay Co.,Ltd. All rights reserved.
//

#import "ViewController.h"
#import "UPPaymentControl.h"

#define KBtn_width        200
#define KBtn_height       80
#define KXOffSet          (self.view.frame.size.width - KBtn_width) / 2
#define KYOffSet          80
#define kCellHeight_Normal  50
#define kCellHeight_Manual  145

#define kVCTitle          @"商户测试"
#define kBtnFirstTitle    @"获取订单，开始测试"
#define kWaiting          @"正在获取TN,请稍后..."
#define kNote             @"提示"
#define kConfirm          @"确定"
#define kErrorNet         @"网络错误"
#define kResult           @"支付结果：%@"



#define kMode_Development             @"01"
#define kURL_TN_Normal                @"http://101.231.204.84:8091/sim/getacptn"
#define kURL_TN_Configure             @"http://101.231.114.217:8080/sim/app.jsp?user=admin"


@interface ViewController ()<UITableViewDataSource, UITableViewDelegate> {
    
    NSMutableData* _responseData;
    UIAlertView* _alertView;
    CGFloat _maxWidth;
    CGFloat _maxHeight;
    
}


@property (nonatomic, strong) NSArray* labels;
@property(nonatomic, copy)NSString *tnMode;
@property (nonnull,strong)UITextField *tnProductText;
@property (nonnull,strong)UITextField *tnPMText;
@property (nonnull,strong)UITextField *tnTestText;

- (void)startNetWithURL:(NSURL *)url;


@end

@implementation NSURLRequest (NSURLRequestWithIgnoreSSL)
+ (BOOL)allowsAnyHTTPSCertificateForHost:(NSString *)host
{
    return YES;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self extendedLayout];

    self.labels = [NSArray arrayWithObjects:@"DEVELOPER",@"TEST",@"PM",@"RELEASE",@"WALLET",nil];
    
    UITableView* tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, _maxWidth, _maxHeight)];
    [self.view addSubview:tableView];
    
    tableView.delegate = self;
    tableView.dataSource = self;
    
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(updateTitle) name:@"updateTitleForUPPay" object:nil];
    
    [[UPPaymentControl defaultControl] getDirectApps:@"01" withMerchantInfo:@"" succBlock:^(NSArray *directApps) {
        
    } failBlock:^(NSString *code, NSString *msg) {
        
    }];
}

- (void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:@"updateTitleForUPPay"];

}

- (void)viewDidAppear:(BOOL)animated
{
    [self updateTitle];
}


- (void)updateTitle
{
    self.title=@"银行联调用商户Demo";

}




- (void)extendedLayout
{
    BOOL iOS7 = [UIDevice currentDevice].systemVersion.floatValue >= 7.0;
    if (iOS7) {
        self.edgesForExtendedLayout = UIRectEdgeNone;
        self.automaticallyAdjustsScrollViewInsets = NO;
    }
    
    CGFloat offset = iOS7 ? 64 : 44;
    _maxWidth = CGRectGetWidth([UIScreen mainScreen].bounds);
    _maxHeight = CGRectGetHeight([UIScreen mainScreen].bounds)-offset;
    
    self.navigationController.navigationBar.translucent = NO;
}




- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)startNetWithURL:(NSURL *)url
{
    //    [_curField resignFirstResponder];
    //    _curField = nil;
    [self showAlertWait];
    
    NSURLRequest * urlRequest=[NSURLRequest requestWithURL:url];
    NSURLConnection* urlConn = [[NSURLConnection alloc] initWithRequest:urlRequest delegate:self];
    [urlConn start];
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    switch (indexPath.row) {
        case 0:
             [tableView deselectRowAtIndexPath:indexPath animated:YES];
            return;
            break;
            
        case 1:
            [tableView deselectRowAtIndexPath:indexPath animated:YES];
            break;
            
            
        default:
            break;
    }
    
    
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 3;
}

- (void) productVerify {
    self.tnMode = @"00";
    [[UPPaymentControl defaultControl] startPay:self.tnProductText.text fromScheme:@"paydemo" mode:self.tnMode viewController:self];
}

- (void) pmVerify {
    self.tnMode = @"01";
    [[UPPaymentControl defaultControl] startPay:self.tnPMText.text fromScheme:@"paydemo" mode:self.tnMode viewController:self];
}

- (void) testVerify {
    self.tnMode = @"02";
    [[UPPaymentControl defaultControl] startPay:self.tnTestText.text fromScheme:@"paydemo" mode:self.tnMode viewController:self];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:nil];
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    cell.detailTextLabel.font = [UIFont systemFontOfSize:10];
    switch (indexPath.row) {
        case 0:
        {
            UIButton* btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            [btnStartPay setTitle:@"生产验证" forState:UIControlStateNormal];
            [btnStartPay addTarget:self action:@selector(productVerify) forControlEvents:UIControlEventTouchUpInside];
            [btnStartPay setFrame:CGRectMake(240, 10, 80, 40)];
            [cell.contentView addSubview:btnStartPay];
            
            self.tnProductText = [[UITextField alloc] initWithFrame:CGRectMake(20,10,210,40)];
            self.tnProductText.placeholder = @"请在此处输入正式环境tn";
            self.tnProductText.keyboardType = UIKeyboardTypeNumbersAndPunctuation;
            [cell.contentView addSubview:self.tnProductText];
            
            cell.accessoryType = UITableViewCellAccessoryNone;

        }
            
            break;
            
        case 1:
        {
            UIButton* btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            [btnStartPay setTitle:@"PM验证" forState:UIControlStateNormal];
            [btnStartPay addTarget:self action:@selector(pmVerify) forControlEvents:UIControlEventTouchUpInside];
            [btnStartPay setFrame:CGRectMake(240, 10, 80, 40)];
            [cell.contentView addSubview:btnStartPay];
            
            self.tnPMText = [[UITextField alloc] initWithFrame:CGRectMake(20,10,210,40)];
            self.tnPMText.placeholder = @"请在此处输入PM环境tn";
            self.tnPMText.keyboardType = UIKeyboardTypeNumbersAndPunctuation;
            [cell.contentView addSubview:self.tnPMText];
            
            cell.accessoryType = UITableViewCellAccessoryNone;

        }
            
            break;
            
        case 2:
        {
            UIButton* btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            btnStartPay = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            [btnStartPay setTitle:@"测试验证" forState:UIControlStateNormal];
            [btnStartPay addTarget:self action:@selector(testVerify) forControlEvents:UIControlEventTouchUpInside];
            [btnStartPay setFrame:CGRectMake(240, 10, 80, 40)];
            [cell.contentView addSubview:btnStartPay];
            
            self.tnTestText = [[UITextField alloc] initWithFrame:CGRectMake(20,10,210,40)];
            self.tnTestText.placeholder = @"请在此处输入test环境tn";
            self.tnTestText.keyboardType = UIKeyboardTypeNumbersAndPunctuation;
            [cell.contentView addSubview:self.tnTestText];
            
            cell.accessoryType = UITableViewCellAccessoryNone;

        }
            
            break;
            
            
        default:
            break;
    }
    
    
    
    return cell;
    
    
}


#pragma mark - connection

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse*)response
{
    NSHTTPURLResponse* rsp = (NSHTTPURLResponse*)response;
    NSInteger code = [rsp statusCode];
    if (code != 200)
    {
        
        [self showAlertMessage:kErrorNet];
        [connection cancel];
    }
    else
    {
        _responseData = [[NSMutableData alloc] init];
    }
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [_responseData appendData:data];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    [self hideAlert];
    NSString* tn = [[NSMutableString alloc] initWithData:_responseData encoding:NSUTF8StringEncoding];
    if (tn != nil && tn.length > 0)
    {
        [[UPPaymentControl defaultControl] startPay:tn fromScheme:@"paydemo" mode:self.tnMode viewController:self];
    }
    
}


#pragma mark - Alert

- (void)showAlertWait
{
    [self hideAlert];
    _alertView = [[UIAlertView alloc] initWithTitle:kWaiting message:nil delegate:self cancelButtonTitle:nil otherButtonTitles: nil];
    [_alertView show];
    UIActivityIndicatorView* aiv = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhite];
    aiv.center = CGPointMake(_alertView.frame.size.width / 2.0f - 15, _alertView.frame.size.height / 2.0f + 10 );
    [aiv startAnimating];
    [_alertView addSubview:aiv];
}

- (void)showAlertMessage:(NSString*)msg
{
    [self hideAlert];
    _alertView = [[UIAlertView alloc] initWithTitle:kNote message:msg delegate:self cancelButtonTitle:kConfirm otherButtonTitles:nil, nil];
    [_alertView show];
}
- (void)hideAlert
{
    if (_alertView != nil)
    {
        [_alertView dismissWithClickedButtonIndex:0 animated:NO];
        _alertView = nil;
    }
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    _alertView = nil;
}


@end
